(*
  Delphi Ogg Vorbis encoder example.
  (c) copyright 2002 by Andrei Borovsky, borovsky@yandex.ru
  You may do with this file whatever you want, but
  remember that I'm not responsible for any consequences.
*)
unit UEnc1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, wav_format, CThrd,
  ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ProgressBar1: TProgressBar;
    Button4: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Panel1: TPanel;
    Label1: TLabel;
    Label4: TLabel;
    TrackBar1: TTrackBar;
    Label2: TLabel;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    FName, OggName : String;
    procedure OpenInputFile;
    procedure OpenOutputFile;
    procedure OnDone;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}


procedure TForm1.Button1Click(Sender: TObject);
begin
  CThrd.ConvertThread.InFile := Fname;
  CThrd.ConvertThread.OutFile := OggName;

  CThrd.ConvertThread.Compression := TrackBar1.Position/10;

  Button1.Enabled := False;

  Button4.Enabled := True;

  Label4.Caption := Label4.Caption +Char(10)+'Quality: '+IntToStr(TrackBar1.position)+Char(10)+'Converting...';

  CThrd.ConvertThread.Resume;

end;


procedure TForm1.Button2Click(Sender: TObject);
begin
  Button1.Enabled := False;
  Label1.Caption := '';
  FName := '';
  if OpenDialog1.Execute then
  begin
    FName := OpenDialog1.FileName;
    OpenInputFile;
  end;
end;

procedure TForm1.OpenInputFile;
var
  F : file of Byte;
  Hdr : TWavHeader;
  Tmp : array[0..4] of Byte;
  Seconds : Integer;
begin
  Label1.Caption := '';
  if OggName = '' then Label4.Caption := '';
  AssignFile(F, FName);
  Reset(F);
  if FileSize(F) <= WAVHeaderOffs then
  begin
    Label1.Caption := 'Selected file isn''t a valid wav file';
    FName := '';
    CloseFile(F);
    Exit;
  end;
  BlockRead(F, Hdr, WAVHeaderOffs);
  CloseFile(F);
  Tmp[4] := 0;
  Move(Hdr.RIFF[0], Tmp[0], 4);
  if PChar(@TMP[0]) <> 'RIFF' then
  begin
    Label1.Caption := 'Selected file isn''t a valid wav file';
    FName := '';
    Exit;
  end;
  Move(Hdr.RIFFType[0], Tmp[0], 4);
  if PChar(@TMP[0]) <> 'WAVE' then
  begin
    Label1.Caption := 'Selected file isn''t a valid wav file';
    FName := '';
    Exit;
  end;
  if Hdr.FormatTag <> WAV_FORMAT_PCM then
  begin
    Label1.Caption := 'Selected file is''nt a PCM wav file';
    FName := '';
    Exit;
  end;
  if (Hdr.BitsPerSample <> 16) or (Hdr.Channels<>2) then
  begin
    Label1.Caption := 'Selected file is in a format that cannot be converted (not a 16-bit stereo).';
    FName := '';
    Exit;
  end;
  Seconds := Round(Hdr.DataSize/4/Hdr.SampleRate);
  // now we're shure we're dealing with right wav file
  Label1.Caption := 'Input file: '+ExtractFileName(FName)+Char(10)+
  'Sample rate: '+IntToStr(Hdr.SampleRate)+' Hz'+Char(10)+'Time: '+IntToStr(Seconds div 60)+':';
  if (Seconds mod 60) < 10 then Label1.Caption := Label1.Caption + '0';
  Label1.Caption := Label1.Caption + IntToStr(Seconds mod 60);
  if (FName<>'') and (OggName<>'') then Button1.Enabled := True;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Label4.Caption := '';
  OggName := '';
  Button1.Enabled := False;
  if SaveDialog1.Execute then
  begin
    OggName := SaveDialog1.FileName;
    OpenOutputFile;
  end;
end;

procedure TForm1.OpenOutputFile;
begin
  Label4.Caption := '';
  OggName := '';
  if FileExists(SaveDialog1.FileName) then
  if Application.MessageBox('The specified file already exists. Do you want to replace it?', 'Confirm the operation', mb_YesNo+mb_IconQuestion) <> ID_YES then
  begin
    OggName := '';
    Exit;
  end;
  OggName := SaveDialog1.FileName;
  Label4.Caption := 'Output file: '+ExtractFileName(OggName);
  if (FName<>'') and (OggName<>'') then Button1.Enabled := True;
end;

procedure TForm1.OnDone;
begin
  OggName := '';
  Label4.Caption := 'Done!';
  Button4.Enabled := False;
  ProgressBar1.Position:=0;
end;
procedure TForm1.FormCreate(Sender: TObject);
begin
   CThrd.ConvertThread := TConvertThread.Create(True);
   CThrd.ConvertThread.onDone := Self.OnDone;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  Stop := True;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if not Idle then
  ProgressBar1.Position := CThrd.ConvertThread.Progress;
  else
  if not CThrd.ConvertThread.Suspended then
  CThrd.ConvertThread.Suspend;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  CThrd.ConvertThread.Terminate;
  while not Idle do;
  CThrd.ConvertThread.Free;
end;

end.
