(*
  Delphi/Kylix headers for OggVorbis software codec.
  Translated from vorbisenc.h header
  by Andrei Borovsky, borovsky@yandex.ru
  The original C/C++ headers and libraries (C) COPYRIGHT 1994-2001
  by the XIPHOPHORUS Company http://www.xiph.org/
*)

unit VorbisEnc;

interface

uses
  Codec;

function vorbis_encode_init(var vi: VORBIS_INFO;
                            channels: LongInt;
                            rate: LongInt;
                            max_bitrate: LongInt;
                            nominal_bitrate: LongInt;
                            min_bitrate: LongInt): Integer cdecl;

function vorbis_encode_setup_managed(var vi: VORBIS_INFO;
                                     channels: LongInt;
                                     rate: LongInt;
                                     max_bitrate: LongInt;
                                     nominal_bitrate: LongInt;
                                     min_bitrate: LongInt): Integer; cdecl;

function vorbis_encode_setup_vbr(var vi: VORBIS_INFO;
                                 channels: LongInt;
                                 rate: LongInt;
                                 fl: Single): Integer; cdecl;

function vorbis_encode_init_vbr(var vi: VORBIS_INFO;
                                channels: LongInt;
                                rate: LongInt;
                                base_quality: Single): Integer; cdecl;

function vorbis_encode_setup_init(var vi: VORBIS_INFO): Integer; cdecl;

function vorbis_encode_ctl(var vi: VORBIS_INFO;
                           number: Integer;
                           arg: Pointer): Integer; cdecl;


implementation

const
  {$IFDEF LINUX}
  libname = 'libvorbisenc.so';
  {$ENDIF}
  {$IFDEF WIN32}
  libname = 'vorbisenc.dll';
  {$ENDIF}

  function vorbis_encode_init; cdecl; external libname;
  function vorbis_encode_setup_managed; cdecl; external libname;
  function vorbis_encode_setup_vbr; cdecl; external libname;
  function vorbis_encode_init_vbr; cdecl; external libname;
  function vorbis_encode_setup_init; cdecl; external libname;
  function vorbis_encode_ctl; cdecl; external libname;
end.
